package com.dhcc.finance.main.domain;

import java.util.ArrayList;
import java.util.Date;
import java.util.List;

public class CwBdAccsubjExample {
    protected String orderByClause;

    protected boolean distinct;

    protected List<Criteria> oredCriteria;

    public CwBdAccsubjExample() {
        oredCriteria = new ArrayList<Criteria>();
    }

    public void setOrderByClause(String orderByClause) {
        this.orderByClause = orderByClause;
    }

    public String getOrderByClause() {
        return orderByClause;
    }

    public void setDistinct(boolean distinct) {
        this.distinct = distinct;
    }

    public boolean isDistinct() {
        return distinct;
    }

    public List<Criteria> getOredCriteria() {
        return oredCriteria;
    }

    public void or(Criteria criteria) {
        oredCriteria.add(criteria);
    }

    public Criteria or() {
        Criteria criteria = createCriteriaInternal();
        oredCriteria.add(criteria);
        return criteria;
    }

    public Criteria createCriteria() {
        Criteria criteria = createCriteriaInternal();
        if (oredCriteria.size() == 0) {
            oredCriteria.add(criteria);
        }
        return criteria;
    }

    protected Criteria createCriteriaInternal() {
        Criteria criteria = new Criteria();
        return criteria;
    }

    public void clear() {
        oredCriteria.clear();
        orderByClause = null;
        distinct = false;
    }

    protected abstract static class GeneratedCriteria {
        protected List<Criterion> criteria;

        protected GeneratedCriteria() {
            super();
            criteria = new ArrayList<Criterion>();
        }

        public boolean isValid() {
            return criteria.size() > 0;
        }

        public List<Criterion> getAllCriteria() {
            return criteria;
        }

        public List<Criterion> getCriteria() {
            return criteria;
        }

        protected void addCriterion(String condition) {
            if (condition == null) {
                throw new RuntimeException("Value for condition cannot be null");
            }
            criteria.add(new Criterion(condition));
        }

        protected void addCriterion(String condition, Object value, String property) {
            if (value == null) {
                throw new RuntimeException("Value for " + property + " cannot be null");
            }
            criteria.add(new Criterion(condition, value));
        }

        protected void addCriterion(String condition, Object value1, Object value2, String property) {
            if (value1 == null || value2 == null) {
                throw new RuntimeException("Between values for " + property + " cannot be null");
            }
            criteria.add(new Criterion(condition, value1, value2));
        }

        public Criteria andPkAccsubjIsNull() {
            addCriterion("PK_ACCSUBJ is null");
            return (Criteria) this;
        }

        public Criteria andPkAccsubjIsNotNull() {
            addCriterion("PK_ACCSUBJ is not null");
            return (Criteria) this;
        }

        public Criteria andPkAccsubjEqualTo(String value) {
            addCriterion("PK_ACCSUBJ =", value, "pkAccsubj");
            return (Criteria) this;
        }

        public Criteria andPkAccsubjNotEqualTo(String value) {
            addCriterion("PK_ACCSUBJ <>", value, "pkAccsubj");
            return (Criteria) this;
        }

        public Criteria andPkAccsubjGreaterThan(String value) {
            addCriterion("PK_ACCSUBJ >", value, "pkAccsubj");
            return (Criteria) this;
        }

        public Criteria andPkAccsubjGreaterThanOrEqualTo(String value) {
            addCriterion("PK_ACCSUBJ >=", value, "pkAccsubj");
            return (Criteria) this;
        }

        public Criteria andPkAccsubjLessThan(String value) {
            addCriterion("PK_ACCSUBJ <", value, "pkAccsubj");
            return (Criteria) this;
        }

        public Criteria andPkAccsubjLessThanOrEqualTo(String value) {
            addCriterion("PK_ACCSUBJ <=", value, "pkAccsubj");
            return (Criteria) this;
        }

        public Criteria andPkAccsubjLike(String value) {
            addCriterion("PK_ACCSUBJ like", value, "pkAccsubj");
            return (Criteria) this;
        }

        public Criteria andPkAccsubjNotLike(String value) {
            addCriterion("PK_ACCSUBJ not like", value, "pkAccsubj");
            return (Criteria) this;
        }

        public Criteria andPkAccsubjIn(List<String> values) {
            addCriterion("PK_ACCSUBJ in", values, "pkAccsubj");
            return (Criteria) this;
        }

        public Criteria andPkAccsubjNotIn(List<String> values) {
            addCriterion("PK_ACCSUBJ not in", values, "pkAccsubj");
            return (Criteria) this;
        }

        public Criteria andPkAccsubjBetween(String value1, String value2) {
            addCriterion("PK_ACCSUBJ between", value1, value2, "pkAccsubj");
            return (Criteria) this;
        }

        public Criteria andPkAccsubjNotBetween(String value1, String value2) {
            addCriterion("PK_ACCSUBJ not between", value1, value2, "pkAccsubj");
            return (Criteria) this;
        }

        public Criteria andPkSubjschemeIsNull() {
            addCriterion("PK_SUBJSCHEME is null");
            return (Criteria) this;
        }

        public Criteria andPkSubjschemeIsNotNull() {
            addCriterion("PK_SUBJSCHEME is not null");
            return (Criteria) this;
        }

        public Criteria andPkSubjschemeEqualTo(String value) {
            addCriterion("PK_SUBJSCHEME =", value, "pkSubjscheme");
            return (Criteria) this;
        }

        public Criteria andPkSubjschemeNotEqualTo(String value) {
            addCriterion("PK_SUBJSCHEME <>", value, "pkSubjscheme");
            return (Criteria) this;
        }

        public Criteria andPkSubjschemeGreaterThan(String value) {
            addCriterion("PK_SUBJSCHEME >", value, "pkSubjscheme");
            return (Criteria) this;
        }

        public Criteria andPkSubjschemeGreaterThanOrEqualTo(String value) {
            addCriterion("PK_SUBJSCHEME >=", value, "pkSubjscheme");
            return (Criteria) this;
        }

        public Criteria andPkSubjschemeLessThan(String value) {
            addCriterion("PK_SUBJSCHEME <", value, "pkSubjscheme");
            return (Criteria) this;
        }

        public Criteria andPkSubjschemeLessThanOrEqualTo(String value) {
            addCriterion("PK_SUBJSCHEME <=", value, "pkSubjscheme");
            return (Criteria) this;
        }

        public Criteria andPkSubjschemeLike(String value) {
            addCriterion("PK_SUBJSCHEME like", value, "pkSubjscheme");
            return (Criteria) this;
        }

        public Criteria andPkSubjschemeNotLike(String value) {
            addCriterion("PK_SUBJSCHEME not like", value, "pkSubjscheme");
            return (Criteria) this;
        }

        public Criteria andPkSubjschemeIn(List<String> values) {
            addCriterion("PK_SUBJSCHEME in", values, "pkSubjscheme");
            return (Criteria) this;
        }

        public Criteria andPkSubjschemeNotIn(List<String> values) {
            addCriterion("PK_SUBJSCHEME not in", values, "pkSubjscheme");
            return (Criteria) this;
        }

        public Criteria andPkSubjschemeBetween(String value1, String value2) {
            addCriterion("PK_SUBJSCHEME between", value1, value2, "pkSubjscheme");
            return (Criteria) this;
        }

        public Criteria andPkSubjschemeNotBetween(String value1, String value2) {
            addCriterion("PK_SUBJSCHEME not between", value1, value2, "pkSubjscheme");
            return (Criteria) this;
        }

        public Criteria andSubjcodeIsNull() {
            addCriterion("SUBJCODE is null");
            return (Criteria) this;
        }

        public Criteria andSubjcodeIsNotNull() {
            addCriterion("SUBJCODE is not null");
            return (Criteria) this;
        }

        public Criteria andSubjcodeEqualTo(String value) {
            addCriterion("SUBJCODE =", value, "subjcode");
            return (Criteria) this;
        }

        public Criteria andSubjcodeNotEqualTo(String value) {
            addCriterion("SUBJCODE <>", value, "subjcode");
            return (Criteria) this;
        }

        public Criteria andSubjcodeGreaterThan(String value) {
            addCriterion("SUBJCODE >", value, "subjcode");
            return (Criteria) this;
        }

        public Criteria andSubjcodeGreaterThanOrEqualTo(String value) {
            addCriterion("SUBJCODE >=", value, "subjcode");
            return (Criteria) this;
        }

        public Criteria andSubjcodeLessThan(String value) {
            addCriterion("SUBJCODE <", value, "subjcode");
            return (Criteria) this;
        }

        public Criteria andSubjcodeLessThanOrEqualTo(String value) {
            addCriterion("SUBJCODE <=", value, "subjcode");
            return (Criteria) this;
        }

        public Criteria andSubjcodeLike(String value) {
            addCriterion("SUBJCODE like", value, "subjcode");
            return (Criteria) this;
        }

        public Criteria andSubjcodeNotLike(String value) {
            addCriterion("SUBJCODE not like", value, "subjcode");
            return (Criteria) this;
        }

        public Criteria andSubjcodeIn(List<String> values) {
            addCriterion("SUBJCODE in", values, "subjcode");
            return (Criteria) this;
        }

        public Criteria andSubjcodeNotIn(List<String> values) {
            addCriterion("SUBJCODE not in", values, "subjcode");
            return (Criteria) this;
        }

        public Criteria andSubjcodeBetween(String value1, String value2) {
            addCriterion("SUBJCODE between", value1, value2, "subjcode");
            return (Criteria) this;
        }

        public Criteria andSubjcodeNotBetween(String value1, String value2) {
            addCriterion("SUBJCODE not between", value1, value2, "subjcode");
            return (Criteria) this;
        }

        public Criteria andSubjnameIsNull() {
            addCriterion("SUBJNAME is null");
            return (Criteria) this;
        }

        public Criteria andSubjnameIsNotNull() {
            addCriterion("SUBJNAME is not null");
            return (Criteria) this;
        }

        public Criteria andSubjnameEqualTo(String value) {
            addCriterion("SUBJNAME =", value, "subjname");
            return (Criteria) this;
        }

        public Criteria andSubjnameNotEqualTo(String value) {
            addCriterion("SUBJNAME <>", value, "subjname");
            return (Criteria) this;
        }

        public Criteria andSubjnameGreaterThan(String value) {
            addCriterion("SUBJNAME >", value, "subjname");
            return (Criteria) this;
        }

        public Criteria andSubjnameGreaterThanOrEqualTo(String value) {
            addCriterion("SUBJNAME >=", value, "subjname");
            return (Criteria) this;
        }

        public Criteria andSubjnameLessThan(String value) {
            addCriterion("SUBJNAME <", value, "subjname");
            return (Criteria) this;
        }

        public Criteria andSubjnameLessThanOrEqualTo(String value) {
            addCriterion("SUBJNAME <=", value, "subjname");
            return (Criteria) this;
        }

        public Criteria andSubjnameLike(String value) {
            addCriterion("SUBJNAME like", value, "subjname");
            return (Criteria) this;
        }

        public Criteria andSubjnameNotLike(String value) {
            addCriterion("SUBJNAME not like", value, "subjname");
            return (Criteria) this;
        }

        public Criteria andSubjnameIn(List<String> values) {
            addCriterion("SUBJNAME in", values, "subjname");
            return (Criteria) this;
        }

        public Criteria andSubjnameNotIn(List<String> values) {
            addCriterion("SUBJNAME not in", values, "subjname");
            return (Criteria) this;
        }

        public Criteria andSubjnameBetween(String value1, String value2) {
            addCriterion("SUBJNAME between", value1, value2, "subjname");
            return (Criteria) this;
        }

        public Criteria andSubjnameNotBetween(String value1, String value2) {
            addCriterion("SUBJNAME not between", value1, value2, "subjname");
            return (Criteria) this;
        }

        public Criteria andSubjlevIsNull() {
            addCriterion("SUBJLEV is null");
            return (Criteria) this;
        }

        public Criteria andSubjlevIsNotNull() {
            addCriterion("SUBJLEV is not null");
            return (Criteria) this;
        }

        public Criteria andSubjlevEqualTo(String value) {
            addCriterion("SUBJLEV =", value, "subjlev");
            return (Criteria) this;
        }

        public Criteria andSubjlevNotEqualTo(String value) {
            addCriterion("SUBJLEV <>", value, "subjlev");
            return (Criteria) this;
        }

        public Criteria andSubjlevGreaterThan(String value) {
            addCriterion("SUBJLEV >", value, "subjlev");
            return (Criteria) this;
        }

        public Criteria andSubjlevGreaterThanOrEqualTo(String value) {
            addCriterion("SUBJLEV >=", value, "subjlev");
            return (Criteria) this;
        }

        public Criteria andSubjlevLessThan(String value) {
            addCriterion("SUBJLEV <", value, "subjlev");
            return (Criteria) this;
        }

        public Criteria andSubjlevLessThanOrEqualTo(String value) {
            addCriterion("SUBJLEV <=", value, "subjlev");
            return (Criteria) this;
        }

        public Criteria andSubjlevLike(String value) {
            addCriterion("SUBJLEV like", value, "subjlev");
            return (Criteria) this;
        }

        public Criteria andSubjlevNotLike(String value) {
            addCriterion("SUBJLEV not like", value, "subjlev");
            return (Criteria) this;
        }

        public Criteria andSubjlevIn(List<String> values) {
            addCriterion("SUBJLEV in", values, "subjlev");
            return (Criteria) this;
        }

        public Criteria andSubjlevNotIn(List<String> values) {
            addCriterion("SUBJLEV not in", values, "subjlev");
            return (Criteria) this;
        }

        public Criteria andSubjlevBetween(String value1, String value2) {
            addCriterion("SUBJLEV between", value1, value2, "subjlev");
            return (Criteria) this;
        }

        public Criteria andSubjlevNotBetween(String value1, String value2) {
            addCriterion("SUBJLEV not between", value1, value2, "subjlev");
            return (Criteria) this;
        }

        public Criteria andDispnameIsNull() {
            addCriterion("DISPNAME is null");
            return (Criteria) this;
        }

        public Criteria andDispnameIsNotNull() {
            addCriterion("DISPNAME is not null");
            return (Criteria) this;
        }

        public Criteria andDispnameEqualTo(String value) {
            addCriterion("DISPNAME =", value, "dispname");
            return (Criteria) this;
        }

        public Criteria andDispnameNotEqualTo(String value) {
            addCriterion("DISPNAME <>", value, "dispname");
            return (Criteria) this;
        }

        public Criteria andDispnameGreaterThan(String value) {
            addCriterion("DISPNAME >", value, "dispname");
            return (Criteria) this;
        }

        public Criteria andDispnameGreaterThanOrEqualTo(String value) {
            addCriterion("DISPNAME >=", value, "dispname");
            return (Criteria) this;
        }

        public Criteria andDispnameLessThan(String value) {
            addCriterion("DISPNAME <", value, "dispname");
            return (Criteria) this;
        }

        public Criteria andDispnameLessThanOrEqualTo(String value) {
            addCriterion("DISPNAME <=", value, "dispname");
            return (Criteria) this;
        }

        public Criteria andDispnameLike(String value) {
            addCriterion("DISPNAME like", value, "dispname");
            return (Criteria) this;
        }

        public Criteria andDispnameNotLike(String value) {
            addCriterion("DISPNAME not like", value, "dispname");
            return (Criteria) this;
        }

        public Criteria andDispnameIn(List<String> values) {
            addCriterion("DISPNAME in", values, "dispname");
            return (Criteria) this;
        }

        public Criteria andDispnameNotIn(List<String> values) {
            addCriterion("DISPNAME not in", values, "dispname");
            return (Criteria) this;
        }

        public Criteria andDispnameBetween(String value1, String value2) {
            addCriterion("DISPNAME between", value1, value2, "dispname");
            return (Criteria) this;
        }

        public Criteria andDispnameNotBetween(String value1, String value2) {
            addCriterion("DISPNAME not between", value1, value2, "dispname");
            return (Criteria) this;
        }

        public Criteria andRuleIsNull() {
            addCriterion("RULE is null");
            return (Criteria) this;
        }

        public Criteria andRuleIsNotNull() {
            addCriterion("RULE is not null");
            return (Criteria) this;
        }

        public Criteria andRuleEqualTo(String value) {
            addCriterion("RULE =", value, "rule");
            return (Criteria) this;
        }

        public Criteria andRuleNotEqualTo(String value) {
            addCriterion("RULE <>", value, "rule");
            return (Criteria) this;
        }

        public Criteria andRuleGreaterThan(String value) {
            addCriterion("RULE >", value, "rule");
            return (Criteria) this;
        }

        public Criteria andRuleGreaterThanOrEqualTo(String value) {
            addCriterion("RULE >=", value, "rule");
            return (Criteria) this;
        }

        public Criteria andRuleLessThan(String value) {
            addCriterion("RULE <", value, "rule");
            return (Criteria) this;
        }

        public Criteria andRuleLessThanOrEqualTo(String value) {
            addCriterion("RULE <=", value, "rule");
            return (Criteria) this;
        }

        public Criteria andRuleLike(String value) {
            addCriterion("RULE like", value, "rule");
            return (Criteria) this;
        }

        public Criteria andRuleNotLike(String value) {
            addCriterion("RULE not like", value, "rule");
            return (Criteria) this;
        }

        public Criteria andRuleIn(List<String> values) {
            addCriterion("RULE in", values, "rule");
            return (Criteria) this;
        }

        public Criteria andRuleNotIn(List<String> values) {
            addCriterion("RULE not in", values, "rule");
            return (Criteria) this;
        }

        public Criteria andRuleBetween(String value1, String value2) {
            addCriterion("RULE between", value1, value2, "rule");
            return (Criteria) this;
        }

        public Criteria andRuleNotBetween(String value1, String value2) {
            addCriterion("RULE not between", value1, value2, "rule");
            return (Criteria) this;
        }

        public Criteria andPkSubjtypeIsNull() {
            addCriterion("PK_SUBJTYPE is null");
            return (Criteria) this;
        }

        public Criteria andPkSubjtypeIsNotNull() {
            addCriterion("PK_SUBJTYPE is not null");
            return (Criteria) this;
        }

        public Criteria andPkSubjtypeEqualTo(String value) {
            addCriterion("PK_SUBJTYPE =", value, "pkSubjtype");
            return (Criteria) this;
        }

        public Criteria andPkSubjtypeNotEqualTo(String value) {
            addCriterion("PK_SUBJTYPE <>", value, "pkSubjtype");
            return (Criteria) this;
        }

        public Criteria andPkSubjtypeGreaterThan(String value) {
            addCriterion("PK_SUBJTYPE >", value, "pkSubjtype");
            return (Criteria) this;
        }

        public Criteria andPkSubjtypeGreaterThanOrEqualTo(String value) {
            addCriterion("PK_SUBJTYPE >=", value, "pkSubjtype");
            return (Criteria) this;
        }

        public Criteria andPkSubjtypeLessThan(String value) {
            addCriterion("PK_SUBJTYPE <", value, "pkSubjtype");
            return (Criteria) this;
        }

        public Criteria andPkSubjtypeLessThanOrEqualTo(String value) {
            addCriterion("PK_SUBJTYPE <=", value, "pkSubjtype");
            return (Criteria) this;
        }

        public Criteria andPkSubjtypeLike(String value) {
            addCriterion("PK_SUBJTYPE like", value, "pkSubjtype");
            return (Criteria) this;
        }

        public Criteria andPkSubjtypeNotLike(String value) {
            addCriterion("PK_SUBJTYPE not like", value, "pkSubjtype");
            return (Criteria) this;
        }

        public Criteria andPkSubjtypeIn(List<String> values) {
            addCriterion("PK_SUBJTYPE in", values, "pkSubjtype");
            return (Criteria) this;
        }

        public Criteria andPkSubjtypeNotIn(List<String> values) {
            addCriterion("PK_SUBJTYPE not in", values, "pkSubjtype");
            return (Criteria) this;
        }

        public Criteria andPkSubjtypeBetween(String value1, String value2) {
            addCriterion("PK_SUBJTYPE between", value1, value2, "pkSubjtype");
            return (Criteria) this;
        }

        public Criteria andPkSubjtypeNotBetween(String value1, String value2) {
            addCriterion("PK_SUBJTYPE not between", value1, value2, "pkSubjtype");
            return (Criteria) this;
        }

        public Criteria andBalanorientIsNull() {
            addCriterion("BALANORIENT is null");
            return (Criteria) this;
        }

        public Criteria andBalanorientIsNotNull() {
            addCriterion("BALANORIENT is not null");
            return (Criteria) this;
        }

        public Criteria andBalanorientEqualTo(String value) {
            addCriterion("BALANORIENT =", value, "balanorient");
            return (Criteria) this;
        }

        public Criteria andBalanorientNotEqualTo(String value) {
            addCriterion("BALANORIENT <>", value, "balanorient");
            return (Criteria) this;
        }

        public Criteria andBalanorientGreaterThan(String value) {
            addCriterion("BALANORIENT >", value, "balanorient");
            return (Criteria) this;
        }

        public Criteria andBalanorientGreaterThanOrEqualTo(String value) {
            addCriterion("BALANORIENT >=", value, "balanorient");
            return (Criteria) this;
        }

        public Criteria andBalanorientLessThan(String value) {
            addCriterion("BALANORIENT <", value, "balanorient");
            return (Criteria) this;
        }

        public Criteria andBalanorientLessThanOrEqualTo(String value) {
            addCriterion("BALANORIENT <=", value, "balanorient");
            return (Criteria) this;
        }

        public Criteria andBalanorientLike(String value) {
            addCriterion("BALANORIENT like", value, "balanorient");
            return (Criteria) this;
        }

        public Criteria andBalanorientNotLike(String value) {
            addCriterion("BALANORIENT not like", value, "balanorient");
            return (Criteria) this;
        }

        public Criteria andBalanorientIn(List<String> values) {
            addCriterion("BALANORIENT in", values, "balanorient");
            return (Criteria) this;
        }

        public Criteria andBalanorientNotIn(List<String> values) {
            addCriterion("BALANORIENT not in", values, "balanorient");
            return (Criteria) this;
        }

        public Criteria andBalanorientBetween(String value1, String value2) {
            addCriterion("BALANORIENT between", value1, value2, "balanorient");
            return (Criteria) this;
        }

        public Criteria andBalanorientNotBetween(String value1, String value2) {
            addCriterion("BALANORIENT not between", value1, value2, "balanorient");
            return (Criteria) this;
        }

        public Criteria andBalanflagIsNull() {
            addCriterion("BALANFLAG is null");
            return (Criteria) this;
        }

        public Criteria andBalanflagIsNotNull() {
            addCriterion("BALANFLAG is not null");
            return (Criteria) this;
        }

        public Criteria andBalanflagEqualTo(String value) {
            addCriterion("BALANFLAG =", value, "balanflag");
            return (Criteria) this;
        }

        public Criteria andBalanflagNotEqualTo(String value) {
            addCriterion("BALANFLAG <>", value, "balanflag");
            return (Criteria) this;
        }

        public Criteria andBalanflagGreaterThan(String value) {
            addCriterion("BALANFLAG >", value, "balanflag");
            return (Criteria) this;
        }

        public Criteria andBalanflagGreaterThanOrEqualTo(String value) {
            addCriterion("BALANFLAG >=", value, "balanflag");
            return (Criteria) this;
        }

        public Criteria andBalanflagLessThan(String value) {
            addCriterion("BALANFLAG <", value, "balanflag");
            return (Criteria) this;
        }

        public Criteria andBalanflagLessThanOrEqualTo(String value) {
            addCriterion("BALANFLAG <=", value, "balanflag");
            return (Criteria) this;
        }

        public Criteria andBalanflagLike(String value) {
            addCriterion("BALANFLAG like", value, "balanflag");
            return (Criteria) this;
        }

        public Criteria andBalanflagNotLike(String value) {
            addCriterion("BALANFLAG not like", value, "balanflag");
            return (Criteria) this;
        }

        public Criteria andBalanflagIn(List<String> values) {
            addCriterion("BALANFLAG in", values, "balanflag");
            return (Criteria) this;
        }

        public Criteria andBalanflagNotIn(List<String> values) {
            addCriterion("BALANFLAG not in", values, "balanflag");
            return (Criteria) this;
        }

        public Criteria andBalanflagBetween(String value1, String value2) {
            addCriterion("BALANFLAG between", value1, value2, "balanflag");
            return (Criteria) this;
        }

        public Criteria andBalanflagNotBetween(String value1, String value2) {
            addCriterion("BALANFLAG not between", value1, value2, "balanflag");
            return (Criteria) this;
        }

        public Criteria andIcurflagIsNull() {
            addCriterion("ICURFLAG is null");
            return (Criteria) this;
        }

        public Criteria andIcurflagIsNotNull() {
            addCriterion("ICURFLAG is not null");
            return (Criteria) this;
        }

        public Criteria andIcurflagEqualTo(String value) {
            addCriterion("ICURFLAG =", value, "icurflag");
            return (Criteria) this;
        }

        public Criteria andIcurflagNotEqualTo(String value) {
            addCriterion("ICURFLAG <>", value, "icurflag");
            return (Criteria) this;
        }

        public Criteria andIcurflagGreaterThan(String value) {
            addCriterion("ICURFLAG >", value, "icurflag");
            return (Criteria) this;
        }

        public Criteria andIcurflagGreaterThanOrEqualTo(String value) {
            addCriterion("ICURFLAG >=", value, "icurflag");
            return (Criteria) this;
        }

        public Criteria andIcurflagLessThan(String value) {
            addCriterion("ICURFLAG <", value, "icurflag");
            return (Criteria) this;
        }

        public Criteria andIcurflagLessThanOrEqualTo(String value) {
            addCriterion("ICURFLAG <=", value, "icurflag");
            return (Criteria) this;
        }

        public Criteria andIcurflagLike(String value) {
            addCriterion("ICURFLAG like", value, "icurflag");
            return (Criteria) this;
        }

        public Criteria andIcurflagNotLike(String value) {
            addCriterion("ICURFLAG not like", value, "icurflag");
            return (Criteria) this;
        }

        public Criteria andIcurflagIn(List<String> values) {
            addCriterion("ICURFLAG in", values, "icurflag");
            return (Criteria) this;
        }

        public Criteria andIcurflagNotIn(List<String> values) {
            addCriterion("ICURFLAG not in", values, "icurflag");
            return (Criteria) this;
        }

        public Criteria andIcurflagBetween(String value1, String value2) {
            addCriterion("ICURFLAG between", value1, value2, "icurflag");
            return (Criteria) this;
        }

        public Criteria andIcurflagNotBetween(String value1, String value2) {
            addCriterion("ICURFLAG not between", value1, value2, "icurflag");
            return (Criteria) this;
        }

        public Criteria andCurrencyIsNull() {
            addCriterion("CURRENCY is null");
            return (Criteria) this;
        }

        public Criteria andCurrencyIsNotNull() {
            addCriterion("CURRENCY is not null");
            return (Criteria) this;
        }

        public Criteria andCurrencyEqualTo(String value) {
            addCriterion("CURRENCY =", value, "currency");
            return (Criteria) this;
        }

        public Criteria andCurrencyNotEqualTo(String value) {
            addCriterion("CURRENCY <>", value, "currency");
            return (Criteria) this;
        }

        public Criteria andCurrencyGreaterThan(String value) {
            addCriterion("CURRENCY >", value, "currency");
            return (Criteria) this;
        }

        public Criteria andCurrencyGreaterThanOrEqualTo(String value) {
            addCriterion("CURRENCY >=", value, "currency");
            return (Criteria) this;
        }

        public Criteria andCurrencyLessThan(String value) {
            addCriterion("CURRENCY <", value, "currency");
            return (Criteria) this;
        }

        public Criteria andCurrencyLessThanOrEqualTo(String value) {
            addCriterion("CURRENCY <=", value, "currency");
            return (Criteria) this;
        }

        public Criteria andCurrencyLike(String value) {
            addCriterion("CURRENCY like", value, "currency");
            return (Criteria) this;
        }

        public Criteria andCurrencyNotLike(String value) {
            addCriterion("CURRENCY not like", value, "currency");
            return (Criteria) this;
        }

        public Criteria andCurrencyIn(List<String> values) {
            addCriterion("CURRENCY in", values, "currency");
            return (Criteria) this;
        }

        public Criteria andCurrencyNotIn(List<String> values) {
            addCriterion("CURRENCY not in", values, "currency");
            return (Criteria) this;
        }

        public Criteria andCurrencyBetween(String value1, String value2) {
            addCriterion("CURRENCY between", value1, value2, "currency");
            return (Criteria) this;
        }

        public Criteria andCurrencyNotBetween(String value1, String value2) {
            addCriterion("CURRENCY not between", value1, value2, "currency");
            return (Criteria) this;
        }

        public Criteria andAuxflagIsNull() {
            addCriterion("AUXFLAG is null");
            return (Criteria) this;
        }

        public Criteria andAuxflagIsNotNull() {
            addCriterion("AUXFLAG is not null");
            return (Criteria) this;
        }

        public Criteria andAuxflagEqualTo(String value) {
            addCriterion("AUXFLAG =", value, "auxflag");
            return (Criteria) this;
        }

        public Criteria andAuxflagNotEqualTo(String value) {
            addCriterion("AUXFLAG <>", value, "auxflag");
            return (Criteria) this;
        }

        public Criteria andAuxflagGreaterThan(String value) {
            addCriterion("AUXFLAG >", value, "auxflag");
            return (Criteria) this;
        }

        public Criteria andAuxflagGreaterThanOrEqualTo(String value) {
            addCriterion("AUXFLAG >=", value, "auxflag");
            return (Criteria) this;
        }

        public Criteria andAuxflagLessThan(String value) {
            addCriterion("AUXFLAG <", value, "auxflag");
            return (Criteria) this;
        }

        public Criteria andAuxflagLessThanOrEqualTo(String value) {
            addCriterion("AUXFLAG <=", value, "auxflag");
            return (Criteria) this;
        }

        public Criteria andAuxflagLike(String value) {
            addCriterion("AUXFLAG like", value, "auxflag");
            return (Criteria) this;
        }

        public Criteria andAuxflagNotLike(String value) {
            addCriterion("AUXFLAG not like", value, "auxflag");
            return (Criteria) this;
        }

        public Criteria andAuxflagIn(List<String> values) {
            addCriterion("AUXFLAG in", values, "auxflag");
            return (Criteria) this;
        }

        public Criteria andAuxflagNotIn(List<String> values) {
            addCriterion("AUXFLAG not in", values, "auxflag");
            return (Criteria) this;
        }

        public Criteria andAuxflagBetween(String value1, String value2) {
            addCriterion("AUXFLAG between", value1, value2, "auxflag");
            return (Criteria) this;
        }

        public Criteria andAuxflagNotBetween(String value1, String value2) {
            addCriterion("AUXFLAG not between", value1, value2, "auxflag");
            return (Criteria) this;
        }

        public Criteria andParentidIsNull() {
            addCriterion("PARENTID is null");
            return (Criteria) this;
        }

        public Criteria andParentidIsNotNull() {
            addCriterion("PARENTID is not null");
            return (Criteria) this;
        }

        public Criteria andParentidEqualTo(String value) {
            addCriterion("PARENTID =", value, "parentid");
            return (Criteria) this;
        }

        public Criteria andParentidNotEqualTo(String value) {
            addCriterion("PARENTID <>", value, "parentid");
            return (Criteria) this;
        }

        public Criteria andParentidGreaterThan(String value) {
            addCriterion("PARENTID >", value, "parentid");
            return (Criteria) this;
        }

        public Criteria andParentidGreaterThanOrEqualTo(String value) {
            addCriterion("PARENTID >=", value, "parentid");
            return (Criteria) this;
        }

        public Criteria andParentidLessThan(String value) {
            addCriterion("PARENTID <", value, "parentid");
            return (Criteria) this;
        }

        public Criteria andParentidLessThanOrEqualTo(String value) {
            addCriterion("PARENTID <=", value, "parentid");
            return (Criteria) this;
        }

        public Criteria andParentidLike(String value) {
            addCriterion("PARENTID like", value, "parentid");
            return (Criteria) this;
        }

        public Criteria andParentidNotLike(String value) {
            addCriterion("PARENTID not like", value, "parentid");
            return (Criteria) this;
        }

        public Criteria andParentidIn(List<String> values) {
            addCriterion("PARENTID in", values, "parentid");
            return (Criteria) this;
        }

        public Criteria andParentidNotIn(List<String> values) {
            addCriterion("PARENTID not in", values, "parentid");
            return (Criteria) this;
        }

        public Criteria andParentidBetween(String value1, String value2) {
            addCriterion("PARENTID between", value1, value2, "parentid");
            return (Criteria) this;
        }

        public Criteria andParentidNotBetween(String value1, String value2) {
            addCriterion("PARENTID not between", value1, value2, "parentid");
            return (Criteria) this;
        }

        public Criteria andFinalstageIsNull() {
            addCriterion("FINALSTAGE is null");
            return (Criteria) this;
        }

        public Criteria andFinalstageIsNotNull() {
            addCriterion("FINALSTAGE is not null");
            return (Criteria) this;
        }

        public Criteria andFinalstageEqualTo(String value) {
            addCriterion("FINALSTAGE =", value, "finalstage");
            return (Criteria) this;
        }

        public Criteria andFinalstageNotEqualTo(String value) {
            addCriterion("FINALSTAGE <>", value, "finalstage");
            return (Criteria) this;
        }

        public Criteria andFinalstageGreaterThan(String value) {
            addCriterion("FINALSTAGE >", value, "finalstage");
            return (Criteria) this;
        }

        public Criteria andFinalstageGreaterThanOrEqualTo(String value) {
            addCriterion("FINALSTAGE >=", value, "finalstage");
            return (Criteria) this;
        }

        public Criteria andFinalstageLessThan(String value) {
            addCriterion("FINALSTAGE <", value, "finalstage");
            return (Criteria) this;
        }

        public Criteria andFinalstageLessThanOrEqualTo(String value) {
            addCriterion("FINALSTAGE <=", value, "finalstage");
            return (Criteria) this;
        }

        public Criteria andFinalstageLike(String value) {
            addCriterion("FINALSTAGE like", value, "finalstage");
            return (Criteria) this;
        }

        public Criteria andFinalstageNotLike(String value) {
            addCriterion("FINALSTAGE not like", value, "finalstage");
            return (Criteria) this;
        }

        public Criteria andFinalstageIn(List<String> values) {
            addCriterion("FINALSTAGE in", values, "finalstage");
            return (Criteria) this;
        }

        public Criteria andFinalstageNotIn(List<String> values) {
            addCriterion("FINALSTAGE not in", values, "finalstage");
            return (Criteria) this;
        }

        public Criteria andFinalstageBetween(String value1, String value2) {
            addCriterion("FINALSTAGE between", value1, value2, "finalstage");
            return (Criteria) this;
        }

        public Criteria andFinalstageNotBetween(String value1, String value2) {
            addCriterion("FINALSTAGE not between", value1, value2, "finalstage");
            return (Criteria) this;
        }

        public Criteria andUnitsIsNull() {
            addCriterion("UNITS is null");
            return (Criteria) this;
        }

        public Criteria andUnitsIsNotNull() {
            addCriterion("UNITS is not null");
            return (Criteria) this;
        }

        public Criteria andUnitsEqualTo(String value) {
            addCriterion("UNITS =", value, "units");
            return (Criteria) this;
        }

        public Criteria andUnitsNotEqualTo(String value) {
            addCriterion("UNITS <>", value, "units");
            return (Criteria) this;
        }

        public Criteria andUnitsGreaterThan(String value) {
            addCriterion("UNITS >", value, "units");
            return (Criteria) this;
        }

        public Criteria andUnitsGreaterThanOrEqualTo(String value) {
            addCriterion("UNITS >=", value, "units");
            return (Criteria) this;
        }

        public Criteria andUnitsLessThan(String value) {
            addCriterion("UNITS <", value, "units");
            return (Criteria) this;
        }

        public Criteria andUnitsLessThanOrEqualTo(String value) {
            addCriterion("UNITS <=", value, "units");
            return (Criteria) this;
        }

        public Criteria andUnitsLike(String value) {
            addCriterion("UNITS like", value, "units");
            return (Criteria) this;
        }

        public Criteria andUnitsNotLike(String value) {
            addCriterion("UNITS not like", value, "units");
            return (Criteria) this;
        }

        public Criteria andUnitsIn(List<String> values) {
            addCriterion("UNITS in", values, "units");
            return (Criteria) this;
        }

        public Criteria andUnitsNotIn(List<String> values) {
            addCriterion("UNITS not in", values, "units");
            return (Criteria) this;
        }

        public Criteria andUnitsBetween(String value1, String value2) {
            addCriterion("UNITS between", value1, value2, "units");
            return (Criteria) this;
        }

        public Criteria andUnitsNotBetween(String value1, String value2) {
            addCriterion("UNITS not between", value1, value2, "units");
            return (Criteria) this;
        }

        public Criteria andEnablestateIsNull() {
            addCriterion("ENABLESTATE is null");
            return (Criteria) this;
        }

        public Criteria andEnablestateIsNotNull() {
            addCriterion("ENABLESTATE is not null");
            return (Criteria) this;
        }

        public Criteria andEnablestateEqualTo(String value) {
            addCriterion("ENABLESTATE =", value, "enablestate");
            return (Criteria) this;
        }

        public Criteria andEnablestateNotEqualTo(String value) {
            addCriterion("ENABLESTATE <>", value, "enablestate");
            return (Criteria) this;
        }

        public Criteria andEnablestateGreaterThan(String value) {
            addCriterion("ENABLESTATE >", value, "enablestate");
            return (Criteria) this;
        }

        public Criteria andEnablestateGreaterThanOrEqualTo(String value) {
            addCriterion("ENABLESTATE >=", value, "enablestate");
            return (Criteria) this;
        }

        public Criteria andEnablestateLessThan(String value) {
            addCriterion("ENABLESTATE <", value, "enablestate");
            return (Criteria) this;
        }

        public Criteria andEnablestateLessThanOrEqualTo(String value) {
            addCriterion("ENABLESTATE <=", value, "enablestate");
            return (Criteria) this;
        }

        public Criteria andEnablestateLike(String value) {
            addCriterion("ENABLESTATE like", value, "enablestate");
            return (Criteria) this;
        }

        public Criteria andEnablestateNotLike(String value) {
            addCriterion("ENABLESTATE not like", value, "enablestate");
            return (Criteria) this;
        }

        public Criteria andEnablestateIn(List<String> values) {
            addCriterion("ENABLESTATE in", values, "enablestate");
            return (Criteria) this;
        }

        public Criteria andEnablestateNotIn(List<String> values) {
            addCriterion("ENABLESTATE not in", values, "enablestate");
            return (Criteria) this;
        }

        public Criteria andEnablestateBetween(String value1, String value2) {
            addCriterion("ENABLESTATE between", value1, value2, "enablestate");
            return (Criteria) this;
        }

        public Criteria andEnablestateNotBetween(String value1, String value2) {
            addCriterion("ENABLESTATE not between", value1, value2, "enablestate");
            return (Criteria) this;
        }

        public Criteria andUseStateIsNull() {
            addCriterion("USE_STATE is null");
            return (Criteria) this;
        }

        public Criteria andUseStateIsNotNull() {
            addCriterion("USE_STATE is not null");
            return (Criteria) this;
        }

        public Criteria andUseStateEqualTo(String value) {
            addCriterion("USE_STATE =", value, "useState");
            return (Criteria) this;
        }

        public Criteria andUseStateNotEqualTo(String value) {
            addCriterion("USE_STATE <>", value, "useState");
            return (Criteria) this;
        }

        public Criteria andUseStateGreaterThan(String value) {
            addCriterion("USE_STATE >", value, "useState");
            return (Criteria) this;
        }

        public Criteria andUseStateGreaterThanOrEqualTo(String value) {
            addCriterion("USE_STATE >=", value, "useState");
            return (Criteria) this;
        }

        public Criteria andUseStateLessThan(String value) {
            addCriterion("USE_STATE <", value, "useState");
            return (Criteria) this;
        }

        public Criteria andUseStateLessThanOrEqualTo(String value) {
            addCriterion("USE_STATE <=", value, "useState");
            return (Criteria) this;
        }

        public Criteria andUseStateLike(String value) {
            addCriterion("USE_STATE like", value, "useState");
            return (Criteria) this;
        }

        public Criteria andUseStateNotLike(String value) {
            addCriterion("USE_STATE not like", value, "useState");
            return (Criteria) this;
        }

        public Criteria andUseStateIn(List<String> values) {
            addCriterion("USE_STATE in", values, "useState");
            return (Criteria) this;
        }

        public Criteria andUseStateNotIn(List<String> values) {
            addCriterion("USE_STATE not in", values, "useState");
            return (Criteria) this;
        }

        public Criteria andUseStateBetween(String value1, String value2) {
            addCriterion("USE_STATE between", value1, value2, "useState");
            return (Criteria) this;
        }

        public Criteria andUseStateNotBetween(String value1, String value2) {
            addCriterion("USE_STATE not between", value1, value2, "useState");
            return (Criteria) this;
        }

        public Criteria andCreateUserIsNull() {
            addCriterion("CREATE_USER is null");
            return (Criteria) this;
        }

        public Criteria andCreateUserIsNotNull() {
            addCriterion("CREATE_USER is not null");
            return (Criteria) this;
        }

        public Criteria andCreateUserEqualTo(String value) {
            addCriterion("CREATE_USER =", value, "createUser");
            return (Criteria) this;
        }

        public Criteria andCreateUserNotEqualTo(String value) {
            addCriterion("CREATE_USER <>", value, "createUser");
            return (Criteria) this;
        }

        public Criteria andCreateUserGreaterThan(String value) {
            addCriterion("CREATE_USER >", value, "createUser");
            return (Criteria) this;
        }

        public Criteria andCreateUserGreaterThanOrEqualTo(String value) {
            addCriterion("CREATE_USER >=", value, "createUser");
            return (Criteria) this;
        }

        public Criteria andCreateUserLessThan(String value) {
            addCriterion("CREATE_USER <", value, "createUser");
            return (Criteria) this;
        }

        public Criteria andCreateUserLessThanOrEqualTo(String value) {
            addCriterion("CREATE_USER <=", value, "createUser");
            return (Criteria) this;
        }

        public Criteria andCreateUserLike(String value) {
            addCriterion("CREATE_USER like", value, "createUser");
            return (Criteria) this;
        }

        public Criteria andCreateUserNotLike(String value) {
            addCriterion("CREATE_USER not like", value, "createUser");
            return (Criteria) this;
        }

        public Criteria andCreateUserIn(List<String> values) {
            addCriterion("CREATE_USER in", values, "createUser");
            return (Criteria) this;
        }

        public Criteria andCreateUserNotIn(List<String> values) {
            addCriterion("CREATE_USER not in", values, "createUser");
            return (Criteria) this;
        }

        public Criteria andCreateUserBetween(String value1, String value2) {
            addCriterion("CREATE_USER between", value1, value2, "createUser");
            return (Criteria) this;
        }

        public Criteria andCreateUserNotBetween(String value1, String value2) {
            addCriterion("CREATE_USER not between", value1, value2, "createUser");
            return (Criteria) this;
        }

        public Criteria andCreateTimeIsNull() {
            addCriterion("CREATE_TIME is null");
            return (Criteria) this;
        }

        public Criteria andCreateTimeIsNotNull() {
            addCriterion("CREATE_TIME is not null");
            return (Criteria) this;
        }

        public Criteria andCreateTimeEqualTo(Date value) {
            addCriterion("CREATE_TIME =", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeNotEqualTo(Date value) {
            addCriterion("CREATE_TIME <>", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeGreaterThan(Date value) {
            addCriterion("CREATE_TIME >", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeGreaterThanOrEqualTo(Date value) {
            addCriterion("CREATE_TIME >=", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeLessThan(Date value) {
            addCriterion("CREATE_TIME <", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeLessThanOrEqualTo(Date value) {
            addCriterion("CREATE_TIME <=", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeIn(List<Date> values) {
            addCriterion("CREATE_TIME in", values, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeNotIn(List<Date> values) {
            addCriterion("CREATE_TIME not in", values, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeBetween(Date value1, Date value2) {
            addCriterion("CREATE_TIME between", value1, value2, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeNotBetween(Date value1, Date value2) {
            addCriterion("CREATE_TIME not between", value1, value2, "createTime");
            return (Criteria) this;
        }

        public Criteria andUpdateUserIsNull() {
            addCriterion("UPDATE_USER is null");
            return (Criteria) this;
        }

        public Criteria andUpdateUserIsNotNull() {
            addCriterion("UPDATE_USER is not null");
            return (Criteria) this;
        }

        public Criteria andUpdateUserEqualTo(String value) {
            addCriterion("UPDATE_USER =", value, "updateUser");
            return (Criteria) this;
        }

        public Criteria andUpdateUserNotEqualTo(String value) {
            addCriterion("UPDATE_USER <>", value, "updateUser");
            return (Criteria) this;
        }

        public Criteria andUpdateUserGreaterThan(String value) {
            addCriterion("UPDATE_USER >", value, "updateUser");
            return (Criteria) this;
        }

        public Criteria andUpdateUserGreaterThanOrEqualTo(String value) {
            addCriterion("UPDATE_USER >=", value, "updateUser");
            return (Criteria) this;
        }

        public Criteria andUpdateUserLessThan(String value) {
            addCriterion("UPDATE_USER <", value, "updateUser");
            return (Criteria) this;
        }

        public Criteria andUpdateUserLessThanOrEqualTo(String value) {
            addCriterion("UPDATE_USER <=", value, "updateUser");
            return (Criteria) this;
        }

        public Criteria andUpdateUserLike(String value) {
            addCriterion("UPDATE_USER like", value, "updateUser");
            return (Criteria) this;
        }

        public Criteria andUpdateUserNotLike(String value) {
            addCriterion("UPDATE_USER not like", value, "updateUser");
            return (Criteria) this;
        }

        public Criteria andUpdateUserIn(List<String> values) {
            addCriterion("UPDATE_USER in", values, "updateUser");
            return (Criteria) this;
        }

        public Criteria andUpdateUserNotIn(List<String> values) {
            addCriterion("UPDATE_USER not in", values, "updateUser");
            return (Criteria) this;
        }

        public Criteria andUpdateUserBetween(String value1, String value2) {
            addCriterion("UPDATE_USER between", value1, value2, "updateUser");
            return (Criteria) this;
        }

        public Criteria andUpdateUserNotBetween(String value1, String value2) {
            addCriterion("UPDATE_USER not between", value1, value2, "updateUser");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeIsNull() {
            addCriterion("UPDATE_TIME is null");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeIsNotNull() {
            addCriterion("UPDATE_TIME is not null");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeEqualTo(Date value) {
            addCriterion("UPDATE_TIME =", value, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeNotEqualTo(Date value) {
            addCriterion("UPDATE_TIME <>", value, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeGreaterThan(Date value) {
            addCriterion("UPDATE_TIME >", value, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeGreaterThanOrEqualTo(Date value) {
            addCriterion("UPDATE_TIME >=", value, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeLessThan(Date value) {
            addCriterion("UPDATE_TIME <", value, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeLessThanOrEqualTo(Date value) {
            addCriterion("UPDATE_TIME <=", value, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeIn(List<Date> values) {
            addCriterion("UPDATE_TIME in", values, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeNotIn(List<Date> values) {
            addCriterion("UPDATE_TIME not in", values, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeBetween(Date value1, Date value2) {
            addCriterion("UPDATE_TIME between", value1, value2, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeNotBetween(Date value1, Date value2) {
            addCriterion("UPDATE_TIME not between", value1, value2, "updateTime");
            return (Criteria) this;
        }

        public Criteria andRemarkIsNull() {
            addCriterion("REMARK is null");
            return (Criteria) this;
        }

        public Criteria andRemarkIsNotNull() {
            addCriterion("REMARK is not null");
            return (Criteria) this;
        }

        public Criteria andRemarkEqualTo(String value) {
            addCriterion("REMARK =", value, "remark");
            return (Criteria) this;
        }

        public Criteria andRemarkNotEqualTo(String value) {
            addCriterion("REMARK <>", value, "remark");
            return (Criteria) this;
        }

        public Criteria andRemarkGreaterThan(String value) {
            addCriterion("REMARK >", value, "remark");
            return (Criteria) this;
        }

        public Criteria andRemarkGreaterThanOrEqualTo(String value) {
            addCriterion("REMARK >=", value, "remark");
            return (Criteria) this;
        }

        public Criteria andRemarkLessThan(String value) {
            addCriterion("REMARK <", value, "remark");
            return (Criteria) this;
        }

        public Criteria andRemarkLessThanOrEqualTo(String value) {
            addCriterion("REMARK <=", value, "remark");
            return (Criteria) this;
        }

        public Criteria andRemarkLike(String value) {
            addCriterion("REMARK like", value, "remark");
            return (Criteria) this;
        }

        public Criteria andRemarkNotLike(String value) {
            addCriterion("REMARK not like", value, "remark");
            return (Criteria) this;
        }

        public Criteria andRemarkIn(List<String> values) {
            addCriterion("REMARK in", values, "remark");
            return (Criteria) this;
        }

        public Criteria andRemarkNotIn(List<String> values) {
            addCriterion("REMARK not in", values, "remark");
            return (Criteria) this;
        }

        public Criteria andRemarkBetween(String value1, String value2) {
            addCriterion("REMARK between", value1, value2, "remark");
            return (Criteria) this;
        }

        public Criteria andRemarkNotBetween(String value1, String value2) {
            addCriterion("REMARK not between", value1, value2, "remark");
            return (Criteria) this;
        }
    }

    public static class Criteria extends GeneratedCriteria {

        protected Criteria() {
            super();
        }
    }

    public static class Criterion {
        private String condition;

        private Object value;

        private Object secondValue;

        private boolean noValue;

        private boolean singleValue;

        private boolean betweenValue;

        private boolean listValue;

        private String typeHandler;

        public String getCondition() {
            return condition;
        }

        public Object getValue() {
            return value;
        }

        public Object getSecondValue() {
            return secondValue;
        }

        public boolean isNoValue() {
            return noValue;
        }

        public boolean isSingleValue() {
            return singleValue;
        }

        public boolean isBetweenValue() {
            return betweenValue;
        }

        public boolean isListValue() {
            return listValue;
        }

        public String getTypeHandler() {
            return typeHandler;
        }

        protected Criterion(String condition) {
            super();
            this.condition = condition;
            this.typeHandler = null;
            this.noValue = true;
        }

        protected Criterion(String condition, Object value, String typeHandler) {
            super();
            this.condition = condition;
            this.value = value;
            this.typeHandler = typeHandler;
            if (value instanceof List<?>) {
                this.listValue = true;
            } else {
                this.singleValue = true;
            }
        }

        protected Criterion(String condition, Object value) {
            this(condition, value, null);
        }

        protected Criterion(String condition, Object value, Object secondValue, String typeHandler) {
            super();
            this.condition = condition;
            this.value = value;
            this.secondValue = secondValue;
            this.typeHandler = typeHandler;
            this.betweenValue = true;
        }

        protected Criterion(String condition, Object value, Object secondValue) {
            this(condition, value, secondValue, null);
        }
    }
}